package br.ufes.inf.prog3.lista1;

import java.util.Scanner;

/**
 * Programa que verifica se as componentes de um vetor de 10 componentes inteiros lidos pelo teclado formam uma
 * progressão aritmética, informando se sim ou se não. Caso forme, imprima o termo inicial e a razão. Corresponde ao
 * exercício 5 da lista 1.
 * 
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public class Exercicio05 {
	/** Constante que determina o tamanho do vetor. */
	private static final int TAMANHO_VETOR = 10;

	/** Método principal. */
	public static void main(String[] args) {
		int[] vetor = new int[10];

		// Lê os números do vetor.
		Scanner scanner = new Scanner(System.in);
		System.out.println("Digite " + TAMANHO_VETOR + " números inteiros positivos separados por espaço ou Enter.");
		for (int i = 0; i < vetor.length; i++)
			vetor[i] = scanner.nextInt();
		scanner.close();

		// Assume-se que o vetor forma uma PA e que a razão é a diferença entre os primeiros dois elementos.
		boolean pa = true;
		int razao = vetor[1] - vetor[0];
		
		// Confere o restante do vetor, verificando se a diferença entre todos os termos é igual à razão.
		for (int i = 1; i < vetor.length; i++)
			if (vetor[i] - vetor[i - 1] != razao)
				pa = false;
		
		// Informa o resultado.
		if (pa)
			System.out.println("O vetor forma uma PA com termo inicial " + vetor[0] + " e razão " + razao);
		else
			System.out.println("O vetor não forma uma PA.");
	}
}
