package br.ufes.inf.prog3.lista1;

import java.util.Scanner;

/**
 * Programa que multiplica duas matrizes, conforme enunciado do exercício 6, lista 1.
 * 
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public class Exercicio06 {
	/**
	 * Constante que determina o tamanho das matrizes. O primeiro elemento indica o número de linhas da matriz A, o
	 * terceiro o número de colunas da matriz B, o segundo elemento indica o número de colunas de A e o número de linhas
	 * de B, que deve ser igual para que as matrizes possam ser multiplicadas.
	 */
	private static final int[] TAMANHO_MATRIZES = new int[] { 5, 4, 6 };

	/** Método principal. */
	public static void main(String[] args) {
		double[][] A = new double[TAMANHO_MATRIZES[0]][TAMANHO_MATRIZES[1]], B = new double[TAMANHO_MATRIZES[1]][TAMANHO_MATRIZES[2]];

		// Lê o conteúdo das matrizes.
		Scanner scanner = new Scanner(System.in);
		leMatriz(scanner, A, "A");
		leMatriz(scanner, B, "B");
		scanner.close();

		// Multiplica as matrizes, formando a matriz AB.
		double[][] AB = new double[TAMANHO_MATRIZES[0]][TAMANHO_MATRIZES[2]];
		for (int i = 0; i < AB.length; i++)
			for (int j = 0; j < AB.length; j++)
				for (int k = 0; k < B.length; k++)
					AB[i][j] += A[i][k] * B[k][j];

		// Imprime as matrizes lidas na tela e a matriz AB resultante da multiplicação.
		imprimeMatriz(A, "A");
		imprimeMatriz(B, "B");
		imprimeMatriz(AB, "A x B");
	}

	/**
	 * Lê o conteúdo de uma matriz do console.
	 * 
	 * @param matriz
	 *          Matriz na qual armazenar os dados informados pelo usuário.
	 * @param nome
	 *          Nome da matriz, para imprimir uma mensagem informativa antes da leitura da mesma.
	 */
	private static void leMatriz(Scanner scanner, double[][] matriz, String nome) {
		// Obtém o número de linhas e colunas da própria matriz.
		int linhas = matriz.length;
		int colunas = (linhas == 0) ? 0 : matriz[0].length;

		// Lê as informações do console.
		System.out.printf("Digite %d números reais separados por espaço ou Enter para a matriz %s[%d][%d].%n", linhas * colunas, nome, linhas, colunas);
		for (int i = 0; i < linhas; i++)
			for (int j = 0; j < colunas; j++)
				matriz[i][j] = scanner.nextDouble();
		System.out.println();
	}

	/**
	 * Imprime o conteúdo de uma matriz no console.
	 * 
	 * @param matriz
	 *          Matriz a ser impressa.
	 * @param nome
	 *          Nome da matriz, a ser impresso antes do conteúdo.
	 */
	private static void imprimeMatriz(double[][] matriz, String nome) {
		System.out.println(nome + " = ");
		for (int i = 0; i < matriz.length; i++) {
			for (int j = 0; j < matriz[i].length; j++)
				System.out.printf("%.2f\t", matriz[i][j]);
			System.out.println();
		}
	}
}
