package br.ufes.inf.prog3.lista1.exercicio08;

import java.util.Random;

/**
 * Classe que representa números aleatórios.
 * 
 * Parte do exercício 8, da lista 1.
 *
 * @author Vitor E. Silva Souza (vitorsouza@gmail.com)
 * @version 1.0
 */
public class Aleatorio {
	/** Objeto da classe Random compartilhado por todas as instâncias de Aleatorio. */
	private static Random random = new Random(System.currentTimeMillis());

	/** Constante (usada internamente) que define o valor máximo padrão para o número aleatório. */
	private static final int VALOR_MAXIMO_DEFAULT = 20;
	
	/** Atributo que armazena o valor numérico aleatório. */
	private int numero;
	
	/** Construtor que recebe o valor máximo como parâmetro. */
	public Aleatorio(int valorMaximo) {
		numero = random.nextInt(valorMaximo);
	}
	
	/** Construtor que usa o valor máximo padrão. */
	public Aleatorio() {
		this(VALOR_MAXIMO_DEFAULT);
	}
	
	/** Método que retorna o valor do número aleatório. */
	public int getNumero() {
		return numero;
	}
}
